﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

using Extensibility;

namespace AppUpdateAddin
{

	public class PickListDialogModel : ICommand, IDialogContent
	{

		public string SelectedValue = null;
		private int _iSelectedIndex = -1;

		// Bindable properties

		public List<string> Values { get; private set; }

		public int ValuesSelectedIndex
		{
			get { return _iSelectedIndex; }
			set
			{
				_iSelectedIndex = value;
				if (_iSelectedIndex > -1)
					SelectedValue = Values[_iSelectedIndex];
			}
		}

		public ICommand Command { get { return this; } }

		// ICommand

		public bool CanExecute(object parameter)
		{
			return true;
		}

		public event EventHandler CanExecuteChanged { add { } remove { } } // Not used

		public void Execute(object parameter)
		{
			string sParam = parameter as string;
			switch (sParam)
			{
				case "OK":
					if (this.DialogOK == null)
						break;
					this.DialogOK(this, new EventArgs());
					break;
				case "Cancel":
					if (this.DialogCancel == null)
						break;
					this.DialogCancel(this, new EventArgs());
					break;
			}
			
		}

		// IDialogContent

		public string Title { get; private set; }

		public bool Closable { get { return true; } }

		public event EventHandler<EventArgs> DialogOK;

		public event EventHandler<EventArgs> DialogCancel;

		// Constructor

		public PickListDialogModel(List<string> ValueList, string sTitle, string sDefault = "")
		{
			Title = sTitle;
			Values = ValueList;
			if (ValueList.Count == 0)
				return;
			ValuesSelectedIndex = -1;
			for (int i = 0; i < ValueList.Count; i++)
			{
				if (ValueList[i] != sDefault)
					continue;
				ValuesSelectedIndex = i;
				break;
			}
		}

	}

}
