﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Controls;

using Extensibility;

namespace EditAddin
{

	// AuthenticationDialogModel acts as view model for the Authentication dialog

	public class AuthenticationDialogModel : ICommand, IDialogContent
	{

		public string Password;

		// Bindable properties

		public Visibility UserNameVisibility { get; set; }

		public string UserName { get; set; }

		public ICommand OKCommand { get { return this; } }

		// ICommand

		public bool CanExecute(object parameter)
		{
			return true;
		}

		public event EventHandler CanExecuteChanged { add { } remove { } } // Not used

		public void Execute(object parameter)
		{
			PasswordBox pb = parameter as PasswordBox;
			if (pb == null)
			{
				this.RaiseDialogCancel();
				return;
			}
			Password = pb.Password;
			this.RaiseDialogOK();
		}

		// IDialogContent

		public string Title
		{
			get { return " "; }
		}

		public bool Closable
		{
			get { return true; }
		}

		public event EventHandler<EventArgs> DialogOK;

		public event EventHandler<EventArgs> DialogCancel;

		// Constructor

		public AuthenticationDialogModel()
		{
			UserNameVisibility = Visibility.Visible;
		}

		// Private methods

		private void RaiseDialogOK()
		{
			if (this.DialogOK == null)
				return;
			this.DialogOK(this, new EventArgs());
		}

		private void RaiseDialogCancel()
		{
			if (this.DialogCancel == null)
				return;
			this.DialogCancel(this, new EventArgs());
		}

	}

}
