﻿using System.Windows.Forms;

namespace Extensibility
{

	// DialogHelper helps with some common dialog functions

	public static class DialogHelper
	{

		public static string GetFolder(string sStartDir = null)
		{
			FolderBrowserDialog dlg = new FolderBrowserDialog();
			if (sStartDir != null)
				dlg.SelectedPath = sStartDir;
			DialogResult drResult = dlg.ShowDialog();
			if (drResult != DialogResult.OK)
				return null;
			string sResult = dlg.SelectedPath;
			if (sResult.Substring(sResult.Length - 1) != "\\")
				sResult += "\\";
			return sResult;
		}

		public static string GetInputFile(string sExt = null)
		{
			Microsoft.Win32.OpenFileDialog ofDialog = new Microsoft.Win32.OpenFileDialog();
			if (sExt != null)
				ofDialog.Filter = sExt + " files (*." + sExt + ")|*." + sExt + "|All files (*.*)|*.*";
			if (ofDialog.ShowDialog() != true)
				return null;
			return ofDialog.FileName;
		}

		public static string GetOutputFile(string sExt = null, string sName = null)
		{
			Microsoft.Win32.SaveFileDialog sfDialog = new Microsoft.Win32.SaveFileDialog();
			if (sExt != null)
				sfDialog.Filter = sExt + " files (*." + sExt + ")|*." + sExt + "|All files (*.*)|*.*";
			if (sName != null)
				sfDialog.FileName = sName;
			if (sfDialog.ShowDialog() != true)
				return null;
			return sfDialog.FileName;
		}

	}
}
