﻿using System.Windows;
using System.Windows.Input;
using System.Windows.Interactivity;

using Esri.ArcGISRuntime.UI.Controls;

using Extensibility;

namespace LayoutAddin
{

	// LayoutViewExt manages layout creation

	public class LayoutViewExt : Behavior<MapView>
	{

		public static LayoutViewExt Current { get; private set; }
		private LayoutHelper _lh;

		// Behavior

		protected override void OnAttached()
		{
			base.OnAttached();
			Current = this;
			_lh = new LayoutHelper(AssociatedObject);
		}

		// Public methods

		public void OpenLayout(Layout layout)
		{
			_lh.OpenLayout(layout);
		}

	}
}
