﻿using System.Windows.Input;

using Extensibility;

namespace QueryAddin
{

	// QueryCommands manages Find and GoToXY commands

	public class QueryCommands
	{

		// Bindable layout properties

		public ICommand FindCommand { get; private set; }

		public ICommand GoToXYCommand { get; private set; }

		// Constructors

		public QueryCommands()
		{
			CommandHelper ch;
			ch = new CommandHelper(false);
			ch.AddExecuteAction(this.ExecuteFind);
			ch.AddCanExecuteEvent(QueryModelExt.Current, "CanQueryMap");
			FindCommand = ch;
			ch = new CommandHelper(false);
			ch.AddExecuteAction(this.ExecuteGoToXY);
			ch.AddCanExecuteEvent(QueryModelExt.Current, "CanNavigateMap");
			GoToXYCommand = ch;
		}

		// Private methods

		private void ExecuteFind(object parameter)
		{
			FindDialogModel.Open();
		}

		private void ExecuteGoToXY(object parameter)
		{
			GoToXYDialogModel.Open();
		}

	}

}
